unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ComCtrls, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Label2: TLabel;
    StaticText1: TStaticText;
    Label3: TLabel;
    StaticText3: TStaticText;
    Label5: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    SpeedButton2: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    Timer1: TTimer;
    msglabel: TLabel;
    procedure FormPaint(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure SpeedButton2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const maxN = 12;

var N,K : byte;  //K choices out of N objects
    SH  : word;
    timercode : byte;

procedure resetSH;
//set SH to first combination of K out of N
var i : byte;
    mask : word;
begin
 SH := 0;
 mask := 1;
 for i := 1 to K do
  begin
   mask := mask shl 1;
   SH := SH or mask;
  end; 
end;

function advanceSH : boolean;
//SH shift counter increment
//return true if advanced
//use N,K
var count,pos,i : byte;
    mask : word;
    Done : boolean;
begin
 result := false;
 count := 0;
 pos := N;
 Done := false;
 repeat
  mask := (1 shl pos);
  if SH and mask > 0 then                   //test SH bit
   begin
    SH := SH xor mask;                      //remove 1
    inc(count);                             //count removed 1
    if pos + count <= N then                //test space to shift
     begin
      mask := mask shl 1;                   //next bit
      Done := true;                         
      result := true;
     end
     else
      if count = K then Done := true
       else dec(pos);
   end
   else dec(pos);
 until Done;
 for i := count downto 1 do                 //add removed bits
  begin
   SH := SH xor mask;
   mask := mask shl 1;
  end;
end;

procedure paintedge(box : TPaintbox);
//paint edge on form canvas around paintbox
var x1,y1,x2,y2 : word;
    i : byte;
begin
 with box do
  begin
   x1 := left-2;
   y1 := Top-2;
   x2 := Left + box.Width+1;
   y2 := Top + box.Height + 1;
  end;
 with form1.Canvas do
  begin
   pen.width := 1;
   for i :=0 to 1 do
    begin
     pen.color := $000000;
     moveto(x2-i,y1+i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     pen.color := $808080;
     lineto(x2-i,y2-i);
     lineto(x2-i,y1-i);
    end;
  end;
end;

procedure paintbackground(box : TPaintbox);
var i : word;
begin
 with box do with canvas do
  begin
   brush.Color := $ffffff;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
   i := 40;
   pen.Width := 1;
   pen.Color := $000000;
   while i < width do
    begin
     moveto(i,0);
     lineto(i,height);
     inc(i,40);
    end;
  end;
end;

procedure showNK;
begin
 with form1 do
  begin
   statictext1.Caption := inttostr(N);
   statictext3.Caption := inttostr(K);
  end;
end;

procedure showSH;
var i : byte;
    r : trect;
     ch : char;
begin
 with form1.PaintBox1 do with canvas do
  begin
   brush.Color := $ffffff;
   font.Name := 'arial';
   font.Style := [];
   font.Height := 40;
   font.Color := $000000;
   brush.Style := bsClear;
   for i := 1 to 12 do
    begin
     r.Left := (i-1)*40+1;
     r.Top := 0;
     r.Right := r.left+38;
     r.Bottom := r.Top + 40;
     brush.Style := bsSolid;
     if i <= N then brush.Color := $ffffff else brush.Color := $808080;
     fillrect(r);
     if ((1 shl i) and SH) > 0 then ch := '1' else ch := '0';
     if i <= N then textout(r.Left+10,r.Top,ch);
    end;
  end;
end;

procedure TForm1.FormPaint(Sender: TObject);
var i : byte;
begin
 paintedge(paintbox1);
 with canvas do
  begin
   pen.Color := $000000;
   brush.Style := bsClear;
   font.Name := 'arial';
   font.Height := 16;
   font.Style := [];
   for i := 1 to 12 do textout(40*i-10,170,inttostr(i));
  end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 paintbackground(paintbox1);
 ShowSH;
end;

procedure TForm1.SpeedButton2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
//common for all updown speedbuttons
begin
 timer1.Interval := 330;
 timercode := TSpeedbutton(sender).tag;
 timer1timer(self);
 timer1.Enabled := true;
end;

procedure TForm1.SpeedButton2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//common for all updown speedbuttons
begin
 timer1.Enabled := false;
 timercode := 0;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
//time out event
begin
 case timercode of
  1 : if N < maxN then inc(N);
  2 : if N > 1 then dec(N);
  3 : if K < N then inc(K);
  4 : if K > 1 then dec(K);
 10 : if advanceSH then msglabel.Caption := 'next combination'
       else msglabel.Caption := 'last combination';
 end;
 if timercode < 10 then
  begin
   if N < K then K := N;
   resetSH;
   showNK;
   msglabel.Caption := 'first combination';
  end;
 showSH;
 with timer1 do if interval > 200 then interval := interval -20;//speedup;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 N:= 1;
 K := 1;
 SH := $2;
 showNK;
 msglabel.Caption := 'select objects (N) and choices (K)';
end;

procedure TForm1.SpeedButton1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
//RESET button
begin
 resetSH;
 showSH;
 msglabel.Caption := 'first combination';
end;

procedure TForm1.SpeedButton3MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
//advance button DOWN
begin
 timercode := 10;
 timer1timer(self);
 timer1.Interval := 500;
 timer1.Enabled := true;
end;

procedure TForm1.SpeedButton3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//advance button UP
begin
 timercode := 0;
 timer1.Enabled := false;
end;

end.
